// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.metafacades.uml;

import java.util.Collection;

/**
 * <p>
 * State machines can be used to express the behavior of part of a
 * system. Behavior is modeled as a traversal of a graph of state
 * nodes interconnected by one or more joined transition arcs that
 * are triggered by the dispatching of series of (event)
 * occurrences. During this traversal, the state machine executes a
 * series of activities associated with various elements of the
 * state machine.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface ActivityGraphFacade
    extends StateMachineFacade
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isActivityGraphFacadeMetaType();

    /**
     * <p>
     * The set of action states contained in this activity graph.
     * </p>
     * @return Collection<ActionStateFacade>
     */
    public Collection<ActionStateFacade> getActionStates();

    /**
     * <p>
     * The set of object flow states contained in this activity graph.
     * </p>
     * @return Collection<ObjectFlowStateFacade>
     */
    public Collection<ObjectFlowStateFacade> getObjectFlowStates();

    /**
     * <p>
     * The set of partitions contained in this activity graph.
     * Partitions are also known as swimlanes in UML.
     * </p>
     * @return Collection<PartitionFacade>
     */
    public Collection<PartitionFacade> getPartitions();

    /**
     * <p>
     * The use-case owning this activity graph.
     * </p>
     * @return UseCaseFacade
     */
    public UseCaseFacade getUseCase();
}