// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.metafacades.uml;

/**
 * <p>
 * A property related by memberEnd or its specializations to an
 * association represents an end of the association. The type of
 * the property is the type of the end of the association .Property
 * represents a declared state of one or more instances in terms of
 * a named relationship to a value or values. When a property is an
 * association end, the value or values are related to the instance
 * or instances at the other end(s) of the association.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface AssociationEndFacade
    extends ModelElementFacade
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isAssociationEndFacadeMetaType();

    /**
     * <p>
     * A name suitable for use when adding new elements to this
     * association end in programming code.
     * </p>
     * @return String
     */
    public String getAdderName();

    /**
     * <p>
     * Returns the value of the 'Aggregation' attribute (none, shared,
     * composite). The default value is "none". The literals are from
     * the enumeration org.eclipse.uml2.uml.AggregationKind. Specifies
     * the kind of aggregation that applies to the Property.
     * </p>
     * @return String
     */
    public String getAggregationKind();

    /**
     * <p>
     * The association owning this association end.
     * </p>
     * @return AssociationFacade
     */
    public AssociationFacade getAssociation();

    /**
     * <p>
     * UML2: Returns the value of the 'Default' attribute. Specifies a
     * String that represents a value to be used when no argument is
     * supplied for the Property. A String that is evaluated to give a
     * default value for the Property when an object of the owning
     * Classifier is instantiated.  Can be something like: new
     * ValueObject(values);
     * </p>
     * @return String
     */
    public String getDefault();

    /**
     * <p>
     * A name suitable for use when accessing this association end in
     * programming code.
     * </p>
     * @return String
     */
    public String getGetterName();

    /**
     * <p>
     * The name of the type that is returned on the accessor and
     * mutator operations,  determined in part by the multiplicity.
     * </p>
     * @return String
     */
    public String getGetterSetterTypeName();

    /**
     * <p>
     * the lower value for the multiplicity
     * </p>
     * <p>
     * -only applicable for UML2
     * </p>
     * @return int
     */
    public int getLower();

    /**
     * <p>
     * The other association end owned by this end's association.
     * </p>
     * @return AssociationEndFacade
     */
    public AssociationEndFacade getOtherEnd();

    /**
     * <p>
     * A name suitable for use when removing element from this
     * association end in programming code.
     * </p>
     * @return String
     */
    public String getRemoverName();

    /**
     * <p>
     * A name suitable for use when accessing this association end in
     * programming code.
     * </p>
     * @return String
     */
    public String getSetterName();

    /**
     * <p>
     * The classifier attached to this association end.
     * </p>
     * @return ClassifierFacade
     */
    public ClassifierFacade getType();

    /**
     * <p>
     * the upper value for the multiplicity (will be -1 for *)
     * </p>
     * <p>
     * -only applicable for UML2
     * </p>
     * @return int
     */
    public int getUpper();

    /**
     * <p>
     * True if this association end represents an aggregation
     * relationship.
     * </p>
     * @return boolean
     */
    public boolean isAggregation();

    /**
     * <p>
     * Is true if update of one side of the association should also
     * update the other side. false if not.
     * </p>
     * @return boolean
     */
    public boolean isBidirectional();

    /**
     * <p>
     * Returns whether or not (true/false) this association end is the
     * child end of the assocation (i.e. the other end's aggregation is
     * composition).
     * </p>
     * @return boolean
     */
    public boolean isChild();

    /**
     * <p>
     * True if this association end represents a composition
     * relationship.
     * </p>
     * @return boolean
     */
    public boolean isComposition();

    /**
     * <p>
     * If the association end is derived (its value is computed). UML2
     * only. UML14 always returns false. Default=false.
     * </p>
     * @return boolean
     */
    public boolean isDerived();

    /**
     * <p>
     * IsLeaf property in the association end property. If true,
     * attribute is final, cannot be extended or implemented by a
     * descendant. Default=false.
     * </p>
     * @return boolean
     */
    public boolean isLeaf();

    /**
     * <p>
     * True if this association end's multiplicity is greater than one.
     * </p>
     * @return boolean
     */
    public boolean isMany();

    /**
     * <p>
     * True if this association end's and the other end's
     * multiplicities are both many.
     * </p>
     * @return boolean
     */
    public boolean isMany2Many();

    /**
     * <p>
     * True if this association end's multiplicity is many while the
     * other end's is one.
     * </p>
     * @return boolean
     */
    public boolean isMany2One();

    /**
     * <p>
     * True if it is possible to navigate from the other end to this
     * association end .
     * </p>
     * @return boolean
     */
    public boolean isNavigable();

    /**
     * <p>
     * True if this association end's multiplicity is one while the
     * other end's is many.
     * </p>
     * @return boolean
     */
    public boolean isOne2Many();

    /**
     * <p>
     * True if this association end's and the other end's
     * multiplicities are both one.
     * </p>
     * @return boolean
     */
    public boolean isOne2One();

    /**
     * <p>
     * Indicates whether or not the association ends are ordered (if
     * multiplicity is greater than 1).
     * </p>
     * @return boolean
     */
    public boolean isOrdered();

    /**
     * <p>
     * True if the association end cannot be changed.
     * </p>
     * @return boolean
     */
    public boolean isReadOnly();

    /**
     * <p>
     * True if this association end's multiplicity is strictly greater
     * than zero.
     * </p>
     * @return boolean
     */
    public boolean isRequired();

    /**
     * <p>
     * UML2: If the association attribute is unique within the
     * Collection type. UML14 always returns false. Unique+Ordered
     * determines the implementation Collection type. Default=false.
     * </p>
     * @return boolean
     */
    public boolean isUnique();
}