// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.metafacades.uml;

import java.util.List;

/**
 * <p>
 * An association describes a set of tuples whose values refer to
 * typed instances. An instance of an association is called a link.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface AssociationFacade
    extends GeneralizableElementFacade
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isAssociationFacadeMetaType();

    /**
     * <p>
     * The first association end.
     * </p>
     * @return AssociationEndFacade
     */
    public AssociationEndFacade getAssociationEndA();

    /**
     * <p>
     * The second association end.
     * </p>
     * @return AssociationEndFacade
     */
    public AssociationEndFacade getAssociationEndB();

    /**
     * <p>
     * Gets the association ends belonging to this association.
     * </p>
     * @return List<AssociationEndFacade>
     */
    public List<AssociationEndFacade> getAssociationEnds();

    /**
     * <p>
     * A name suited for naming this relationship. This name will be
     * constructed from both association ends.
     * </p>
     * @return String
     */
    public String getRelationName();

    /**
     * <p>
     * Indicates if this association is 'abstract'.
     * </p>
     * @return boolean
     */
    public boolean isAbstract();

    /**
     * 
     * @return boolean
     */
    public boolean isAssociationClass();

    /**
     * <p>
     * UML2: Determines whether this association is a binary
     * association, i.e. whether it has exactly two member ends. UML2
     * allows association classes in the association itself (many2many
     * with association attributes). Default=true: only two member
     * ends.
     * </p>
     * @return boolean
     */
    public boolean isBinary();

    /**
     * <p>
     * UML2: Returns the value of the 'Is Derived' attribute. The
     * default value is "false". If isDerived is true, the value of the
     * attribute is derived from information elsewhere. Specifies
     * whether the Property is derived, i.e., whether its value or
     * values can be computed from other information.
     * </p>
     * @return boolean
     */
    public boolean isDerived();

    /**
     * <p>
     * True if this association cannot be extended and represent a leaf
     * in the inheritance tree.
     * </p>
     * @return boolean
     */
    public boolean isLeaf();

    /**
     * <p>
     * Indicates whether or not this associations represents a
     * many-to-many relation.
     * </p>
     * @return boolean
     */
    public boolean isMany2Many();
}