// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.metafacades.uml;

/**
 * <p>
 * Condition or restriction expressed in natural language text or
 * in a machine readable language for the purpose of declaring some
 * of the semantics of an element.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface ConstraintFacade
    extends ModelElementFacade
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isConstraintFacadeMetaType();

    /**
     * <p>
     * Gets the 'body' or text of this constraint.
     * </p>
     * @return String
     */
    public String getBody();

    /**
     * <p>
     * Gets the model element to which the constraint applies (i.e. is
     * the context of).
     * </p>
     * @return ModelElementFacade
     */
    public ModelElementFacade getContextElement();

    /**
     * <p>
     * This constraint's translation for the argument languange.
     * </p>
     * @param language String
     * @return String
     */
    public String getTranslation(String language);

    /**
     * <p>
     * True if this constraint denotes a body expression.
     * </p>
     * <p>
     * For example:
     * </p>
     * <p>
     * <pre>
     * </p>
     * <p>
     * context CustomerCard:getTransaction(from:Date, until:Date)
     * </p>
     * <p>
     * body: transactions->select(date.isAfter(from) and
     * date.isBefore(until))
     * </p>
     * <p>
     * </pre>
     * </p>
     * <p>
     * False otherwise.
     * </p>
     * @return boolean
     */
    public boolean isBodyExpression();

    /**
     * <p>
     * True if this constraint denotes a definition.
     * </p>
     * <p>
     * For example:
     * </p>
     * <p>
     * <pre>
     * </p>
     * <p>
     * context CustomerCard
     * </p>
     * <p>
     * def: getTotalPoints(d: date) : Integer =
     * transaction->select(date.isAfter(d)).points->sum()
     * </p>
     * <p>
     * </pre>
     * </p>
     * <p>
     * False otherwise.
     * </p>
     * @return boolean
     */
    public boolean isDefinition();

    /**
     * <p>
     * True if this constraint denotes an invariant.
     * </p>
     * <p>
     * For example:
     * </p>
     * <p>
     * <pre>
     * </p>
     * <p>
     * context LivingAnimal
     * </p>
     * <p>
     * inv: alive = true
     * </p>
     * <p>
     * </pre>
     * </p>
     * <p>
     * False otherwise.
     * </p>
     * @return boolean
     */
    public boolean isInvariant();

    /**
     * <p>
     * True if this constraint denotes a postcondition.
     * </p>
     * <p>
     * For example:
     * </p>
     * <p>
     * <pre>
     * </p>
     * <p>
     * context LivingAnimal::getNumberOfLegs()
     * </p>
     * <p>
     * post: numberOfLegs >= 0
     * </p>
     * <p>
     * </pre>
     * </p>
     * <p>
     * False otherwise.
     * </p>
     * @return boolean
     */
    public boolean isPostCondition();

    /**
     * <p>
     * True if this constraint denotes a precondition.
     * </p>
     * <p>
     * For example:
     * </p>
     * <p>
     * <pre>
     * </p>
     * <p>
     * context LivingAnimal::canFly()
     * </p>
     * <p>
     * pre: hasWings = true
     * </p>
     * <p>
     * </pre>
     * </p>
     * <p>
     * False otherwise.
     * </p>
     * @return boolean
     */
    public boolean isPreCondition();
}