// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.metafacades.uml;

import java.util.Collection;

/**
 * <p>
 * Represents a persistent entity.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface Entity
    extends ClassifierFacade
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isEntityMetaType();

    /**
     * <p>
     * Returns a collection of all entities this entity and its
     * ancestors have a relation to.
     * </p>
     * @return Collection<DependencyFacade>
     */
    public Collection<DependencyFacade> getAllEntityReferences();

    /**
     * <p>
     * Gets a comma separated list of attribute names.  If 'follow' is
     * true, will travel up the inheritance hiearchy to include
     * attributes in parent entities as well.  If 'withIdentifiers' is
     * true, will include identifiers.
     * </p>
     * @param follow boolean
     * @param withIdentifiers boolean
     * @return String
     */
    public String getAttributeNameList(boolean follow, boolean withIdentifiers);

    /**
     * <p>
     * Gets a comma separated list of attribute names.  If 'follow' is
     * true, will travel up the inheritance hiearchy to include
     * attributes in parent entities as well.  If 'withIdentifiers' is
     * true, will include identifiers  and  if 'withDerived' is set to
     * true, will include derived attributes.
     * </p>
     * @param follow boolean
     * @param withIdentifiers boolean
     * @param withDerived boolean
     * @return String
     */
    public String getAttributeNameList(boolean follow, boolean withIdentifiers, boolean withDerived);

    /**
     * <p>
     * Gets a comma separated list of attribute types.  If 'follow' is
     * true, will travel up the inheritance hierarchy to include
     * attributes in parent entities as well.  If 'withIdentifiers' is
     * true, will include identifiers.
     * </p>
     * @param follow boolean
     * @param withIdentifiers boolean
     * @return String
     */
    public String getAttributeTypeList(boolean follow, boolean withIdentifiers);

    /**
     * <p>
     * Gets all attributes of the entity, and optionally retieves the
     * super entities attributes as well as excludes the entity's
     * identifiers if 'withIdentifiers' is set to false.
     * </p>
     * @param follow boolean
     * @param withIdentifiers boolean
     * @return Collection
     */
    public Collection getAttributes(boolean follow, boolean withIdentifiers);

    /**
     * <p>
     * Gets all attributes of the entity, and optionally retieves the
     * super entities attributes as well as excludes the entity's
     * identifiers if 'withIdentifiers' is set to false and exclude
     * derived attributes if 'withDerived' is set to false.
     * </p>
     * @param follow boolean
     * @param withIdentifiers boolean
     * @param withDerived boolean
     * @return Collection
     */
    public Collection getAttributes(boolean follow, boolean withIdentifiers, boolean withDerived);

    /**
     * <p>
     * All business operations of the entity, these include any
     * operations that aren't queries.
     * </p>
     * @return Collection<OperationFacade>
     */
    public Collection<OperationFacade> getBusinessOperations();

    /**
     * <p>
     * Gets any children association ends (i.e. entity association ends
     * that are participants in an association with this entity and
     * this entity has composite aggregation defined for those
     * associations).
     * </p>
     * @return Collection<EntityAssociationEnd>
     */
    public Collection<EntityAssociationEnd> getChildEnds();

    /**
     * <p>
     * The embedded values belonging to this entity.
     * </p>
     * @return Collection
     */
    public Collection getEmbeddedValues();

    /**
     * <p>
     * All entities referenced by this entity.
     * </p>
     * @return Collection<DependencyFacade>
     */
    public Collection<DependencyFacade> getEntityReferences();

    /**
     * <p>
     * The full name of the type of the identifier. If composite
     * identifier add the PK sufix to the class name. If not, retorns
     * the fully qualified name of the identifier.
     * </p>
     * @return String
     */
    public String getFullyQualifiedIdentifierTypeName();

    /**
     * <p>
     * Gets all the associationEnds of this entity marked with the
     * identifiers stereotype.
     * </p>
     * @return Collection
     */
    public Collection getIdentifierAssociationEnds();

    /**
     * <p>
     * The getter name of the identifier.
     * </p>
     * @return String
     */
    public String getIdentifierGetterName();

    /**
     * <p>
     * The name of the identifier. If composite identifier add the Pk
     * sufix. If not composite returns the atribute name of the
     * identifier.
     * </p>
     * @return String
     */
    public String getIdentifierName();

    /**
     * <p>
     * The setter name of the identifier.
     * </p>
     * @return String
     */
    public String getIdentifierSetterName();

    /**
     * <p>
     * The name of the type of the identifier. If composite identifier
     * add the PK sufix to the class name. If not, retorns the name of
     * the identifier.
     * </p>
     * @return String
     */
    public String getIdentifierTypeName();

    /**
     * <p>
     * All the attributes of the entity which make up its identifier
     * (primary key).  Will search any super classes as well.  If no
     * identifiers exist, a default identifier will be created if the
     * allowDefaultIdentifiers property is set to true.
     * </p>
     * @return Collection<EntityAttribute>
     */
    public Collection<EntityAttribute> getIdentifiers();

    /**
     * <p>
     * Gets all identifiers for an entity. If 'follow' is true, and if
     * no identifiers can be found on the entity, a search up the
     * inheritance chain will be performed, and the identifiers from
     * the first super class having them will be used.   If no
     * identifiers exist, a default identifier will be created if the
     * allowDefaultIdentifiers property is set to true.
     * </p>
     * @param follow boolean
     * @return Collection
     */
    public Collection getIdentifiers(boolean follow);

    /**
     * <p>
     * The maximum length a SQL name may be.
     * </p>
     * @return short
     */
    public short getMaxSqlNameLength();

    /**
     * <p>
     * Gets the attributes as a list within an operation call,
     * optionally including the type names and the identifier
     * attributes.
     * </p>
     * @param withIdentifiers boolean
     * @return String
     */
    public String getOperationCallFromAttributes(boolean withIdentifiers);

    /**
     * <p>
     * Gets the attributes as a list within an operation call.  If
     * 'withTypeNames' is true, it will include the type names, if
     * 'withIdentifiers' is true it will include the identifiers.  If
     * 'follow' is true it will follow the inheritance hierarchy and
     * get the attributes of the super class as well.
     * </p>
     * @param withIdentifiers boolean
     * @param follow boolean
     * @return String
     */
    public String getOperationCallFromAttributes(boolean withIdentifiers, boolean follow);

    /**
     * <p>
     * Returns the parent association end of this entity if its a child
     * entity.  The parent is the entity that is the participant the
     * association that has composite aggregation defined.  Will return
     * null if the entity has no parent.
     * </p>
     * @return EntityAssociationEnd
     */
    public EntityAssociationEnd getParentEnd();

    /**
     * <p>
     * Gets all properties of this entity, this includes the attributes
     * and navigable association ends of the entity.  The 'follow' flag
     * indcates whether or not the inheritance hierarchy should be
     * followed when getting all the properties.  The 'withIdentifiers'
     * flag indicates whether or not identifiers should be included in
     * the collection of properties.
     * </p>
     * @param follow boolean
     * @param withIdentifiers boolean
     * @return Collection
     */
    public Collection getProperties(boolean follow, boolean withIdentifiers);

    /**
     * <p>
     * Returns all the operations that can perform queries on the
     * entity.
     * </p>
     * @return Collection<EntityQueryOperation>
     */
    public Collection<EntityQueryOperation> getQueryOperations();

    /**
     * <p>
     * Gets all query operations for an entity. If 'follow' is true,
     * and if no query operations can be found on the entity, a search
     * up the inheritance chain will be performed, and the identifiers
     * from the first super class having them will be used.   If no
     * identifiers exist, a default identifier will be created if the
     * allowDefaultIdentifiers property is set to true.
     * </p>
     * @param follow boolean
     * @return Collection
     */
    public Collection getQueryOperations(boolean follow);

    /**
     * <p>
     * Gets a comma separated list of required attribute names.  If
     * 'follow' is true, will travel up the inheritance hierarchy to
     * include attributes in parent entities as well.  If
     * 'withIdentifiers' is true, will include identifiers.
     * </p>
     * @param follow boolean
     * @param withIdentifiers boolean
     * @return String
     */
    public String getRequiredAttributeNameList(boolean follow, boolean withIdentifiers);

    /**
     * <p>
     * Gets a comma separated list of attribute types with are
     * required.  If 'follow' is true, will travel up the inheritance
     * hierarchy to include attributes in parent entities as well.  If
     * 'withIdentifiers' is true, will include identifiers.
     * </p>
     * @param follow boolean
     * @param withIdentifiers boolean
     * @return String
     */
    public String getRequiredAttributeTypeList(boolean follow, boolean withIdentifiers);

    /**
     * <p>
     * Returns all attributes that are specified as 'required' in the
     * model.  If 'follow' is true, then required attributes in super
     * classes will also be returned, if false, just the ones directly
     * on the entity will be returned.  If 'withIdentifiers' is true,
     * the identifiers will be include, if false, no identifiers will
     * be included.
     * </p>
     * @param follow boolean
     * @param withIdentifiers boolean
     * @return Collection
     */
    public Collection getRequiredAttributes(boolean follow, boolean withIdentifiers);

    /**
     * <p>
     * Gets all required properties for this entity.  These consist of
     * any required attributes as well as navigable associations that
     * are marked as 'required'.  If 'follow' is true, then the
     * inheritance hierchy will be followed and all required properties
     * from super classes will be included as well.
     * </p>
     * <p>
     * If 'withIdentifiers' is true, the identifiers will be include,
     * if false, no identifiers will be included.
     * </p>
     * @param follow boolean
     * @param withIdentifiers boolean
     * @return Collection
     */
    public Collection getRequiredProperties(boolean follow, boolean withIdentifiers);

    /**
     * <p>
     * Creates a comma separated list of the required property names.
     * </p>
     * @param follow boolean
     * @param withIdentifiers boolean
     * @return String
     */
    public String getRequiredPropertyNameList(boolean follow, boolean withIdentifiers);

    /**
     * <p>
     * A comma separated list of the required property types.
     * </p>
     * @param follow boolean
     * @param withIdentifiers boolean
     * @return String
     */
    public String getRequiredPropertyTypeList(boolean follow, boolean withIdentifiers);

    /**
     * <p>
     * The name of the schema that contains the database table
     * </p>
     * @return String
     */
    public String getSchema();

    /**
     * <p>
     * The name of the database table to which this entity is
     * persisted.
     * </p>
     * @return String
     */
    public String getTableName();

    /**
     * <p>
     * Returns true/false depending on whether or not this entity
     * represetns a child in an association (this occurs when this
     * entity is on the opposite end of an assocation end defined as
     * composite).
     * </p>
     * @return boolean
     */
    public boolean isChild();

    /**
     * 
     * @return boolean
     */
    public boolean isCompositeIdentifier();

    /**
     * <p>
     * True if the entity has its identifiers dynamically added, false
     * otherwise.
     * </p>
     * @return boolean
     */
    public boolean isDynamicIdentifiersPresent();

    /**
     * <p>
     * True if the entity has any identifiers defined, false otherwise.
     * </p>
     * @return boolean
     */
    public boolean isIdentifiersPresent();

    /**
     * <p>
     * Indiciates if this entity is using an assigned identifier or
     * not.
     * </p>
     * @return boolean
     */
    public boolean isUsingAssignedIdentifier();

    /**
     * <p>
     * Indicates whether or not this entity is using a foreign
     * identifier as its identifiers.  That is: the foreignIdentifier
     * flag was set on an incoming association end and the entity is
     * therefore using the related foreign parent entity's identifier.
     * </p>
     * @return boolean
     */
    public boolean isUsingForeignIdentifier();
}