// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.metafacades.uml;

/**
 * <p>
 * Represents an attribute of an entity.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface EntityAttribute
    extends AttributeFacade
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isEntityAttributeMetaType();

    /**
     * <p>
     * The name of the index to create on a column that persists the
     * entity attribute.
     * </p>
     * @return String
     */
    public String getColumnIndex();

    /**
     * <p>
     * The length of the column that persists this entity attribute.
     * </p>
     * @return String
     */
    public String getColumnLength();

    /**
     * <p>
     * The name of the table column to which this entity is mapped.
     * </p>
     * @return String
     */
    public String getColumnName();

    /**
     * <p>
     * The PIM to language specific mappings for JDBC.
     * </p>
     * @return TypeMappings
     */
    public TypeMappings getJdbcMappings();

    /**
     * <p>
     * The JDBC type for this entity attribute.
     * </p>
     * @return String
     */
    public String getJdbcType();

    /**
     * <p>
     * The SQL mappings (i.e. the mappings which provide PIM to SQL
     * mappings).
     * </p>
     * @return TypeMappings
     */
    public TypeMappings getSqlMappings();

    /**
     * <p>
     * The SQL type for this attribute.
     * </p>
     * @return String
     */
    public String getSqlType();

    /**
     * <p>
     * The name of the unique-key that this unique attribute belongs
     * </p>
     * @return String
     */
    public String getUniqueGroup();

    /**
     * <p>
     * True if this attribute is an identifier for its entity.
     * </p>
     * @return boolean
     */
    public boolean isIdentifier();

    /**
     * <p>
     * Indicates this attribute should be ignored by the persistence
     * layer.
     * </p>
     * @return boolean
     */
    public boolean isTransient();
}