// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.metafacades.uml;

import java.util.List;

/**
 * <p>
 * Represents an operation on the server called by an action.
 * Optionally may defer operations to the controller.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface FrontEndActionState
    extends ActionStateFacade
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isFrontEndActionStateMetaType();

    /**
     * <p>
     * The method name representing this action state.
     * </p>
     * @return String
     */
    public String getActionMethodName();

    /**
     * <p>
     * The actions that pass through this action state.
     * </p>
     * @return List<FrontEndAction>
     */
    public List<FrontEndAction> getContainerActions();

    /**
     * <p>
     * All calls deferred to the controller by this action state.
     * </p>
     * @return List<OperationFacade>
     */
    public List<OperationFacade> getControllerCalls();

    /**
     * <p>
     * All exceptions modelled on this action state.
     * </p>
     * @return List<FrontEndExceptionHandler>
     */
    public List<FrontEndExceptionHandler> getExceptions();

    /**
     * <p>
     * The next transition, there can be only one transition going out
     * of an action state, otherwise decision points should be used
     * (triggers are not supported at the server-side).
     * </p>
     * @return FrontEndForward
     */
    public FrontEndForward getForward();

    /**
     * <p>
     * All calls deferred to the services by this action state.
     * </p>
     * @return List<OperationFacade>
     */
    public List<OperationFacade> getServiceCalls();

    /**
     * <p>
     * True if this element is contained in a FrontEndUseCase.
     * </p>
     * @return boolean
     */
    public boolean isContainedInFrontEndUseCase();

    /**
     * <p>
     * Indicates whether or not this front end action state is server
     * side. Pages, for example, are also action states but they return
     * control to the client.
     * </p>
     * @return boolean
     */
    public boolean isServerSide();
}