// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.metafacades.uml;

import java.util.List;

/**
 * <p>
 * A front end controller is assigned as the context of a use-case.
 * The controller provides the "controlling" of the use case's
 * activity.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface FrontEndController
    extends ClassifierFacade
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isFrontEndControllerMetaType();

    /**
     * <p>
     * All actions that defer to at least one operation of this
     * controller.
     * </p>
     * @return List<FrontEndAction>
     */
    public List<FrontEndAction> getDeferringActions();

    /**
     * <p>
     * Returns all back-end services referenced by this controller.
     * </p>
     * @return List<DependencyFacade>
     */
    public List<DependencyFacade> getServiceReferences();

    /**
     * <p>
     * Returns the use-case "controlled" by this controller.
     * </p>
     * @return FrontEndUseCase
     */
    public FrontEndUseCase getUseCase();
}