// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.metafacades.uml;

import java.util.List;

/**
 * <p>
 * Represents an operation modeled on a controller.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface FrontEndControllerOperation
    extends OperationFacade
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isFrontEndControllerOperationMetaType();

    /**
     * <p>
     * The activity graph in which this controller operation is used.
     * </p>
     * @return FrontEndActivityGraph
     */
    public FrontEndActivityGraph getActivityGraph();

    /**
     * <p>
     * All those actions that contain at least one front-end action
     * state that is deferring to this operation.
     * </p>
     * @return List<FrontEndAction>
     */
    public List<FrontEndAction> getDeferringActions();

    /**
     * <p>
     * The set of fields in the form made up form this controller
     * operation's parameters.
     * </p>
     * @return List<FrontEndParameter>
     */
    public List<FrontEndParameter> getFormFields();

    /**
     * <p>
     * For each front-end controller operation argument there must
     * exist a form field for each action deferring to that operation.
     * This form field must carry the same name and must be of the same
     * type. True if this is the case, false otherwise.
     * </p>
     * @return boolean
     */
    public boolean isAllArgumentsHaveFormFields();

    /**
     * <p>
     * Indicates if the owner of this operation is a controller.
     * </p>
     * @return boolean
     */
    public boolean isOwnerIsController();
}