// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.metafacades.uml;

import java.util.List;

/**
 * <p>
 * A final state represents the end of a use-case, in a "front-end"
 * application this means its the transition into the next
 * front-end use case.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface FrontEndFinalState
    extends FinalStateFacade
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isFrontEndFinalStateMetaType();

    /**
     * <p>
     * Parameters that are directly entering this final state, they
     * will be able to survive a trip to the next use-case.
     * </p>
     * @return List<FrontEndParameter>
     */
    public List<FrontEndParameter> getInterUseCaseParameters();

    /**
     * <p>
     * The use case the final state is "targetting".
     * </p>
     * @return FrontEndUseCase
     */
    public FrontEndUseCase getTargetUseCase();

    /**
     * <p>
     * Indicates if this front end final state is contained within a
     * FrontEndUseCase.
     * </p>
     * @return boolean
     */
    public boolean isContainedInFrontEndUseCase();
}