// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.metafacades.uml;

import java.util.List;

/**
 * <p>
 * A front end forward is any transition between front-end states.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface FrontEndForward
    extends TransitionFacade
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isFrontEndForwardMetaType();

    /**
     * <p>
     * The method name used to delegate to this forward.
     * </p>
     * @return String
     */
    public String getActionMethodName();

    /**
     * <p>
     * The front-end actions directly containing this front-end
     * forward.
     * </p>
     * @return List<FrontEndAction>
     */
    public List<FrontEndAction> getActions();

    /**
     * <p>
     * The trigger for this front-end forward.
     * </p>
     * @return FrontEndEvent
     */
    public FrontEndEvent getDecisionTrigger();

    /**
     * <p>
     * Tthe set of parameter used during transport in this forward.
     * </p>
     * @return List<FrontEndParameter>
     */
    public List<FrontEndParameter> getForwardParameters();

    /**
     * <p>
     * The activity graph which holds this forward if the graph is
     * contained in a FrontEndUseCase.
     * </p>
     * @return FrontEndActivityGraph
     */
    public FrontEndActivityGraph getFrontEndActivityGraph();

    /**
     * <p>
     * The operation to which is called during execution of this
     * front-end forward.
     * </p>
     * @return FrontEndControllerOperation
     */
    public FrontEndControllerOperation getOperationCall();

    /**
     * <p>
     * The use case in which this forward is contained.
     * </p>
     * @return FrontEndUseCase
     */
    public FrontEndUseCase getUseCase();

    /**
     * <p>
     * Indicates if this forward is contained in a FrontEndUseCase.
     * </p>
     * @return boolean
     */
    public boolean isContainedInFrontEndUseCase();

    /**
     * <p>
     * Indicates if this action directly targets a "front-end" view,
     * false otherwise.
     * </p>
     * @return boolean
     */
    public boolean isEnteringView();

    /**
     * <p>
     * Indicates if this forward (transition) is coming out of a
     * front-end view.
     * </p>
     * @return boolean
     */
    public boolean isExitingView();
}