// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.metafacades.uml;

import java.util.Collection;

/**
 * <p>
 * A front-end parameter is a parameter passed between front-end
 * action states.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface FrontEndParameter
    extends ParameterFacade
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isFrontEndParameterMetaType();

    /**
     * <p>
     * The action to which this parameter belongs (if it belongs to an
     * action), otherwise it returns null.
     * </p>
     * @return FrontEndAction
     */
    public FrontEndAction getAction();

    /**
     * <p>
     * Gets the controller operation to which this parameter belongs.
     * </p>
     * @return FrontEndControllerOperation
     */
    public FrontEndControllerOperation getControllerOperation();

    /**
     * <p>
     * A collection of all possible attribute names of a table (this
     * will only work when your table is modeled as an array..not a
     * collection).
     * </p>
     * @return Collection<String>
     */
    public Collection<String> getTableAttributeNames();

    /**
     * <p>
     * All the columns for this parameter if it represents a table
     * variable. If a column is linked by an event (action) a
     * FrontEndParameter instance is included in the return value,
     * otherwise a plain String representing the column name.
     * </p>
     * @return Collection<String>
     */
    public Collection<String> getTableColumnNames();

    /**
     * <p>
     * A list of all attributes which make up the table columns of this
     * table (this only contains attributes when the table is
     * represented by an array).
     * </p>
     * @return Collection<String>
     */
    public Collection<String> getTableColumns();

    /**
     * <p>
     * Represents the view in which this parameter will be used.
     * </p>
     * @return FrontEndView
     */
    public FrontEndView getView();

    /**
     * <p>
     * Indicates whether or not this is an action parameter or not.
     * </p>
     * @return boolean
     */
    public boolean isActionParameter();

    /**
     * <p>
     * Indicates if this parameter is contained in a "front-end" use
     * case.
     * </p>
     * @return boolean
     */
    public boolean isContainedInFrontEndUseCase();

    /**
     * <p>
     * Indicates whether or not this parameter is an argument of a
     * controller operation.
     * </p>
     * @return boolean
     */
    public boolean isControllerOperationArgument();

    /**
     * <p>
     * Indicates whether or not this parameter represents a table.
     * </p>
     * @return boolean
     */
    public boolean isTable();
}