// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.metafacades.uml;

import java.util.List;

/**
 * <p>
 * Represents a use case used in the "front end" of an application.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface FrontEndUseCase
    extends UseCaseFacade
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isFrontEndUseCaseMetaType();

    /**
     * <p>
     * The actions for this use-case. This will include the initial
     * action to start the use-case.
     * </p>
     * @return List<FrontEndAction>
     */
    public List<FrontEndAction> getActions();

    /**
     * <p>
     * Returns the activity graph describing this use-case in more
     * detail.
     * </p>
     * @return FrontEndActivityGraph
     */
    public FrontEndActivityGraph getActivityGraph();

    /**
     * <p>
     * All roles that directly or indirectly related to any "front-end"
     * use cases.
     * </p>
     * @return List<Role>
     */
    public List<Role> getAllRoles();

    /**
     * <p>
     * Returns all struts use-cases in this "front end" application.
     * </p>
     * @return List<FrontEndUseCase>
     */
    public List<FrontEndUseCase> getAllUseCases();

    /**
     * <p>
     * Returns the controller for this use-case.
     * </p>
     * @return FrontEndController
     */
    public FrontEndController getController();

    /**
     * <p>
     * The first view of this use case, this may actually return a view
     * of another use case if the first is found by traveling through
     * the final state.
     * </p>
     * @return FrontEndView
     */
    public FrontEndView getInitialView();

    /**
     * <p>
     * The final states linking to this use case
     * </p>
     * @return List<FrontEndFinalState>
     */
    public List<FrontEndFinalState> getReferencingFinalStates();

    /**
     * <p>
     * Returns all roles that are directly and indirectly associated to
     * this use-case.
     * </p>
     * @return List<Role>
     */
    public List<Role> getRoles();

    /**
     * <p>
     * The variables for all views in this use-case. A parameter
     * qualifies to be a variable when it explicitely and directly
     * receives it via an action.
     * </p>
     * @return List<FrontEndParameter>
     */
    public List<FrontEndParameter> getViewVariables();

    /**
     * <p>
     * All views that are part of this use case.
     * </p>
     * @return List<FrontEndView>
     */
    public List<FrontEndView> getViews();

    /**
     * <p>
     * True if this use-case is the entry point to the front end.
     * </p>
     * @return boolean
     */
    public boolean isEntryUseCase();

    /**
     * <p>
     * Indicates if this use case is "secured".  This is true when
     * there is at least one role associated to it.
     * </p>
     * @return boolean
     */
    public boolean isSecured();
}