// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.metafacades.uml;

import java.util.List;

/**
 * <p>
 * Represents a view within a front end application.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface FrontEndView
    extends FrontEndActionState
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isFrontEndViewMetaType();

    /**
     * <p>
     * All actions that can be triggered on this view.
     * </p>
     * @return List<FrontEndAction>
     */
    public List<FrontEndAction> getActions();

    /**
     * <p>
     * All parameters for each action going out of this view.
     * </p>
     * @return List<FrontEndParameter>
     */
    public List<FrontEndParameter> getAllActionParameters();

    /**
     * <p>
     * All fields from all forms on the given view.
     * </p>
     * @return List<FrontEndParameter>
     */
    public List<FrontEndParameter> getAllFormFields();

    /**
     * <p>
     * All tables belonging to the front end view.
     * </p>
     * @return List<FrontEndParameter>
     */
    public List<FrontEndParameter> getTables();

    /**
     * <p>
     * The use-case of which this view is a member.
     * </p>
     * @return FrontEndUseCase
     */
    public FrontEndUseCase getUseCase();

    /**
     * <p>
     * All those variables that will be present as variables in the
     * target view. These are the trigger parameters on the incoming
     * transitions.
     * </p>
     * @return List<FrontEndParameter>
     */
    public List<FrontEndParameter> getVariables();

    /**
     * <p>
     * True if this element carries the FrontEndView stereotype.
     * </p>
     * @return boolean
     */
    public boolean isFrontEndView();
}