// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.metafacades.uml;

import java.util.Collection;

/**
 * <p>
 * The model element that represents an element that can be
 * generalized or specialized.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface GeneralizableElementFacade
    extends ModelElementFacade
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isGeneralizableElementFacadeMetaType();

    /**
     * <p>
     * Finds the tagged value optional searching the entire inheritance
     * hierarchy if 'follow' is set to true.
     * </p>
     * @param tagName String
     * @param follow boolean
     * @return Object
     */
    public Object findTaggedValue(String tagName, boolean follow);

    /**
     * <p>
     * All generalizations for this generalizable element, goes up the
     * inheritance tree.
     * </p>
     * @return Collection<GeneralizableElementFacade>
     */
    public Collection<GeneralizableElementFacade> getAllGeneralizations();

    /**
     * <p>
     * All specializations (travels down the inheritance hierarchy).
     * </p>
     * @return Collection<GeneralizableElementFacade>
     */
    public Collection<GeneralizableElementFacade> getAllSpecializations();

    /**
     * <p>
     * Gets the direct generalization for this generalizable element.
     * </p>
     * @return GeneralizableElementFacade
     */
    public GeneralizableElementFacade getGeneralization();

    /**
     * <p>
     * Gets the actual links that this generalization element is part
     * of (it plays either the specialization or generalization).
     * </p>
     * @return Collection<GeneralizationFacade>
     */
    public Collection<GeneralizationFacade> getGeneralizationLinks();

    /**
     * <p>
     * A comma separated list of the fully qualified names of all
     * generalizations.
     * </p>
     * @return String
     */
    public String getGeneralizationList();

    /**
     * <p>
     * The element found when you recursively follow the generalization
     * path up to the root. If an element has no generalization itself
     * will be considered the root.
     * </p>
     * @return GeneralizableElementFacade
     */
    public GeneralizableElementFacade getGeneralizationRoot();

    /**
     * 
     * @return Collection<GeneralizableElementFacade>
     */
    public Collection<GeneralizableElementFacade> getGeneralizations();

    /**
     * <p>
     * Gets the direct specializations (i.e. sub elements) for this
     * generalizatble element.
     * </p>
     * @return Collection<GeneralizableElementFacade>
     */
    public Collection<GeneralizableElementFacade> getSpecializations();
}