// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.metafacades.uml;

/**
 * <p>
 * Specification of an argument used to pass information into or
 * out of an invocation of a behavioral feature. Parameters are
 * allowed to be treated as connectable elements. Parameters have
 * support for streaming, exceptions, and parameter sets.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface ParameterFacade
    extends ModelElementFacade
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isParameterFacadeMetaType();

    /**
     * 
     * @return String
     */
    public String getDefaultValue();

    /**
     * <p>
     * UML2: A representation of the literals of the enumeration
     * 'Parameter Effect Kind': CREATE, READ, UPDATE, DELETE. The
     * datatype ParameterEffectKind is an enumeration that indicates
     * the effect of a behavior on values passed in or out of its
     * parameters.
     * </p>
     * @return String
     */
    public String getEffect();

    /**
     * <p>
     * If this parameter is located on an event, this will represent
     * that event.
     * </p>
     * @return EventFacade
     */
    public EventFacade getEvent();

    /**
     * <p>
     * The name to use for accessors getting this parameter from a
     * bean.
     * </p>
     * @return String
     */
    public String getGetterName();

    /**
     * <p>
     * Fully Qualified TypeName, determined in part by multiplicity
     * (for UML2). For UML14, same as getterName.
     * </p>
     * @return String
     */
    public String getGetterSetterTypeName();

    /**
     * <p>
     * Fully Qualified implementation class of TypeName, determined in
     * part by multiplicity (for UML2). If upper multiplicity =1, same
     * as getterSetterTypeName.
     * </p>
     * @return String
     */
    public String getGetterSetterTypeNameImpl();

    /**
     * <p>
     * the lower value for the multiplicity
     * </p>
     * <p>
     * -only applicable for UML2
     * </p>
     * @return int
     */
    public int getLower();

    /**
     * <p>
     * If this parameter is located on an operation, this will
     * represent that operation.
     * </p>
     * @return OperationFacade
     */
    public OperationFacade getOperation();

    /**
     * <p>
     * The name to use for accessors getting this parameter in a bean.
     * </p>
     * @return String
     */
    public String getSetterName();

    /**
     * 
     * @return ClassifierFacade
     */
    public ClassifierFacade getType();

    /**
     * <p>
     * the upper value of the multiplicity (will be -1 for *)
     * </p>
     * <p>
     * -only applicable for UML2
     * </p>
     * @return int
     */
    public int getUpper();

    /**
     * <p>
     * Indicates if the default value is present.
     * </p>
     * @return boolean
     */
    public boolean isDefaultValuePresent();

    /**
     * <p>
     * UML2: Returns the value of the 'Is Exception' attribute. The
     * default value is "false". Tells whether an output parameter may
     * emit a value to the exclusion of the other outputs.
     * </p>
     * @return boolean
     */
    public boolean isException();

    /**
     * <p>
     * True if this parameter is an 'in' parameter.
     * </p>
     * @return boolean
     */
    public boolean isInParameter();

    /**
     * <p>
     * True if this parameter is an inout parameter.
     * </p>
     * @return boolean
     */
    public boolean isInoutParameter();

    /**
     * <p>
     * If upper>1 or upper==unlimited. Only applies to UML2. For UML14,
     * always false.
     * </p>
     * @return boolean
     */
    public boolean isMany();

    /**
     * <p>
     * UML2 Only: Is parameter ordered within the Collection type.
     * Ordered+Unique determines the implementation Collection Type.
     * For UML14, always false.
     * </p>
     * @return boolean
     */
    public boolean isOrdered();

    /**
     * <p>
     * True if this parameter is an 'out' parameter.
     * </p>
     * @return boolean
     */
    public boolean isOutParameter();

    /**
     * <p>
     * True if this parameter is readable, aka an in-parameter, or this
     * feature is unspecified.
     * </p>
     * @return boolean
     */
    public boolean isReadable();

    /**
     * <p>
     * Whether or not this parameter is considered required (i.e must a
     * non-empty value).
     * </p>
     * @return boolean
     */
    public boolean isRequired();

    /**
     * <p>
     * Whether or not this parameter represents a return parameter.
     * </p>
     * @return boolean
     */
    public boolean isReturn();

    /**
     * <p>
     * If Parameter type isMany (UML2), is the parameter unique within
     * the Collection. Unique+Sorted determines pareter implementation
     * type. For UML14, always false.
     * </p>
     * @return boolean
     */
    public boolean isUnique();

    /**
     * <p>
     * True if this parameter is writable, aka an out-parameter, or
     * this feature is unspecified.
     * </p>
     * @return boolean
     */
    public boolean isWritable();
}