// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.metafacades.uml;

import java.util.Collection;

/**
 * <p>
 * Represents a service.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface Service
    extends ClassifierFacade
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isServiceMetaType();

    /**
     * <p>
     * Returns a collection of all entities this service and its
     * ancestors have a relation to.
     * </p>
     * @return Collection<DependencyFacade>
     */
    public Collection<DependencyFacade> getAllEntityReferences();

    /**
     * <p>
     * All messaging destinations that belong to this service and all
     * decendent services.
     * </p>
     * @return Collection<Destination>
     */
    public Collection<Destination> getAllMessagingDestinations();

    /**
     * <p>
     * All roles associated with the service, this includes both roles
     * that have access to the entire service, and any roles that have
     * access to a single operation.
     * </p>
     * @return Collection<Role>
     */
    public Collection<Role> getAllRoles();

    /**
     * <p>
     * Returns a collection of all services this service and its
     * ancestors have a relation to.
     * </p>
     * @return Collection<DependencyFacade>
     */
    public Collection<DependencyFacade> getAllServiceReferences();

    /**
     * <p>
     * References to all entities to which this service has a
     * dependency.
     * </p>
     * @return Collection<DependencyFacade>
     */
    public Collection<DependencyFacade> getEntityReferences();

    /**
     * <p>
     * All messaging destinations available to this service.
     * </p>
     * @return Collection<Destination>
     */
    public Collection<Destination> getMessagingDestinations();

    /**
     * <p>
     * The roles of the service, these are the actor's that can access
     * this service.
     * </p>
     * @return Collection<Role>
     */
    public Collection<Role> getRoles();

    /**
     * <p>
     * References to all services to which this service has a
     * dependency.
     * </p>
     * @return Collection<DependencyFacade>
     */
    public Collection<DependencyFacade> getServiceReferences();
}