// license-header java merge-point
//
// Attention: generated code (by Metafacade.vsl) - do not modify!
//
package org.andromda.metafacades.uml;

import java.util.Collection;

/**
 * <p>
 * Reprsents an operation of a service.
 * </p>
 *
 * Metafacade interface to be used by AndroMDA cartridges.
 */
public interface ServiceOperation
    extends OperationFacade
{
    /**
     * Indicates the metafacade type (used for metafacade mappings).
     *
     * @return boolean always <code>true</code>
     */
    public boolean isServiceOperationMetaType();

    /**
     * <p>
     * The destination for any incoming messages.
     * </p>
     * @return Destination
     */
    public Destination getIncomingDestination();

    /**
     * <p>
     * The destination for any outgoing messages.
     * </p>
     * @return Destination
     */
    public Destination getOutgoingDestination();

    /**
     * <p>
     * The users of the service operation, these are the actor's that
     * can access this operation.
     * </p>
     * @return Collection<Role>
     */
    public Collection<Role> getRoles();

    /**
     * <p>
     * The service which owns the service operation.
     * </p>
     * @return Service
     */
    public Service getService();

    /**
     * <p>
     * Whether or not this operation represents an "incoming" message
     * operation (i.e. it receives messages from Queues or Topics).
     * </p>
     * @return boolean
     */
    public boolean isIncomingMessageOperation();

    /**
     * <p>
     * Whether or not this is operation accepts incoming or outgoing
     * messages.
     * </p>
     * @return boolean
     */
    public boolean isMessageOperation();

    /**
     * <p>
     * Whether or not this service operation represents an "outgoing"
     * messaging operation (i.e. it sends messages to Queues or
     * Topics).
     * </p>
     * @return boolean
     */
    public boolean isOutgoingMessageOperation();
}